REBOL [
	Title:		"rebXR - XML-RPC library for REBOL, basic server component (server interface)"
	File:		%xmlrpc-server-base.r

	Author: 	"Andreas Bolka"
	Email:		andreas.bolka@gmx.net
	Rights: {
		Copyright (C) 2001, 2002 by Andreas Bolka
		Licensed under the Academic Free License version 1.1. 

		See: <URL:http://earl.strain.at/license/afl> or
		<URL:http://www.rosenlaw.com/afl.html>
    }

	Tabs:		4

	CVS-Date:		"$Date: 2002/11/10 00:32:11 $ "
	CVS-Revision:	"$Revision: 1.5 $"
]

generic-serve: func [ 
	http-method 
	http-post-data 
	xmlrpc-methods 
	default-method 
	/local
		response
		call
] [
	response: copy ""
	either any [
		(= "GET" uppercase http-method)
		(= 0 length? http-post-data)
	] [
		; error response (no xmlrpc-request)
		append response "Content-Type: text/plain^/^/"
		append response "no request, no reponse. c'est la vie."
	] [
		call: xmlrpc-marshaler/unmarshal-req http-post-data

		append response "Content-Type: text/xml^/^/"
		either none? find xmlrpc-methods call/1 [
			either not all [ (default-method) (retval: do default-method call) ] [
				; method is not served
				append response xmlrpc-marshaler/marshal-fault -99 "Method not supported!"
			] [
				; default method responded
				append response xmlrpc-marshaler/marshal-resp retval
			]
		] [
			; method response
			append response xmlrpc-marshaler/marshal-resp do call
		]
	]

	response
]

; vim: set ts=4:
