REBOL [
	Title:		"rebXR - XML-RPC library for REBOL, cgi-based server component"
	File:		%xmlrpc-server-cgi.r

	Author: 	"Andreas Bolka"
	Email:		andreas.bolka@gmx.net
	Rights: {
		Copyright (C) 2001, 2002 by Andreas Bolka
		Licensed under the Academic Free License version 1.1. 

		See: <URL:http://earl.strain.at/license/afl> or
		<URL:http://www.rosenlaw.com/afl.html>
    }

	Tabs:		4

	CVS-Date:		"$Date: 2002/11/11 12:36:41 $"
	CVS-Revision:	"$Revision: 1.6 $"
]

; CGI

cgi-serve: func [ 
	xmlrpc-methods 
	/default default-method 
	/local
		len
		post-data
		output
] [
	; read post request
	len: load any [ system/options/cgi/content-length "0"]
	post-data: make string! (len + 10)
	while [len > 0][ len: len - read-io system/ports/input post-data len ]
	replace/all post-data crlf "^/"

	output: generic-serve 
		system/options/cgi/request-method  
		post-data
		xmlrpc-methods
		default-method

	print output
]

; vim: set ts=4:
